<?php

require_once('/var/simplesamlphp/lib/SAML2/Stork_RequestedAttribute.php');

class StorkConstants {

 const SP_VC_FILE = '/var/simplesamlphp/STORK-info-SPs.xml';
 const STORKP_NS  = 'urn:eu:stork:names:tc:STORK:1.0:protocol';
 const SAMLP_NS = 'urn:oasis:names:tc:SAML:2.0:protocol';
 const STORK_NS = 'urn:eu:stork:names:tc:STORK:1.0:assertion';

 const ASSERTION_URL = 'http://sp.local/SP/return.php';
 const SPID = 'DEMO-SP';

 const QAALEVEL = 'stork:QualityAuthenticationAssuranceLevel';
 const SPSECTOR = 'stork:spSector';
 const SPINST = 'stork:spInstitution';
 const SPAPP = 'stork:spApplication';
 const SPCOUNTRY = 'stork:spCountry';
 const EIDSS = 'storkp:eIDSectorShare';
 const EIDCSS = 'storkp:eIDCrossSectorShare';
 const EIDCBS = 'storkp:eIDCrossBorderShare';

    public static $ids = array('eIdentifier', 'givenName', 'surname', 'inheritedFamilyName', 'adoptedFamilyName', 'gender', 'dateOfBirth', 'countryCodeOfBirth', 'nationalityCode', 'maritalStatus', 'eMail', 'pseudonym', 'age', 'isAgeOver', 'canonicalResidenceAddress', 'signedDoc', 'textResidenceAddress', 'title', 'residencePermit', 'fiscalNumber', 'citizenQAALevel');

    private static $confs = array(
    'stork:spSector' => 'DEMO-SP',
    'stork:spInstitution' => 'DEMO-SP',
    'stork:spApplication' => 'DEMO-SP',
    'storkp:eIDSectorShare' => 'true',
    'storkp:eIDCrossSectorShare' => 'true',
    'storkp:eIDCrossBorderShare' => 'true',
    );

  public static $attrs = array(
		'eIdentifier.name' => 'eIdentifier',
		'eIdentifier.uri' => 'http://www.stork.gov.eu/1.0/eIdentifier',
		'eIdentifier.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'eIdentifier.value' => NULL,
		'givenName.name' => 'givenName',
		'givenName.uri' => 'http://www.stork.gov.eu/1.0/givenName',
		'givenName.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'givenName.value' => NULL,
		'surname.name' => 'surname',
		'surname.uri' => 'http://www.stork.gov.eu/1.0/surname',
		'surname.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'surname.value' => NULL,
		'inheritedFamilyName.name' => 'inheritedFamilyName',
		'inheritedFamilyName.uri' => 'http://www.stork.gov.eu/1.0/inheritedFamilyName',
		'inheritedFamilyName.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'inheritedFamilyName.value' => NULL,
		'adoptedFamilyName.name' => 'adoptedFamilyName',
		'adoptedFamilyName.uri' => 'http://www.stork.gov.eu/1.0/adoptedFamilyName',
		'adoptedFamilyName.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'adoptedFamilyName.value' => NULL,
		'gender.name' => 'gender',
		'gender.uri' => 'http://www.stork.gov.eu/1.0/gender',
		'gender.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'gender.value' => NULL,
		'dateOfBirth.name' => 'dateOfBirth',
		'dateOfBirth.uri' => 'http://www.stork.gov.eu/1.0/dateOfBirth',
		'dateOfBirth.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'dateOfBirth.value' => NULL,
		'countryCodeOfBirth.name' => 'countryCodeOfBirth',
		'countryCodeOfBirth.uri' => 'http://www.stork.gov.eu/1.0/countryCodeOfBirth',
		'countryCodeOfBirth.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'countryCodeOfBirth.value' => NULL,
		'nationalityCode.name' => 'nationalityCode',
		'nationalityCode.uri' => 'http://www.stork.gov.eu/1.0/nationalityCode',
		'nationalityCode.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'nationalityCode.value' => NULL,
		'maritalStatus.name' => 'maritalStatus',
		'maritalStatus.uri' => 'http://www.stork.gov.eu/1.0/maritalStatus',
		'maritalStatus.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'maritalStatus.value' => NULL,
		'textResidenceAddress.name' => 'textResidenceAddress',
		'textResidenceAddress.uri' => 'http://www.stork.gov.eu/1.0/textResidenceAddress',
		'textResidenceAddress.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'textResidenceAddress.value' => NULL,
		'canonicalResidenceAddress.name' => 'canonicalResidenceAddress',
		'canonicalResidenceAddress.uri' => 'http://www.stork.gov.eu/1.0/canonicalResidenceAddress',
		'canonicalResidenceAddress.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'canonicalResidenceAddress.value' => NULL,
		'eMail.name' => 'eMail',
		'eMail.uri' => 'http://www.stork.gov.eu/1.0/eMail',
		'eMail.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'eMail.value' => NULL,
		'title.name' => 'title',
		'title.uri' => 'http://www.stork.gov.eu/1.0/title',
		'title.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'title.value' => NULL,
		'residencePermit.name' => 'residencePermit',
		'residencePermit.uri' => 'http://www.stork.gov.eu/1.0/residencePermit',
		'residencePermit.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'residencePermit.value' => NULL,
		'pseudonym.name' => 'pseudonym',
		'pseudonym.uri' => 'http://www.stork.gov.eu/1.0/pseudonym',
		'pseudonym.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'pseudonym.value' => NULL,
		'age.name' => 'age',
		'age.uri' => 'http://www.stork.gov.eu/1.0/age',
		'age.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'age.value' => NULL,
		'isAgeOver.name' => 'isAgeOver',
		'isAgeOver.uri' => 'http://www.stork.gov.eu/1.0/isAgeOver',
		'isAgeOver.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'isAgeOver.value' => '18',
		'signedDoc.name' => 'signedDoc',
		'signedDoc.uri' => 'http://www.stork.gov.eu/1.0/signedDoc',
		'signedDoc.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'signedDoc.value' => '<sl:CreateXMLSignatureRequest xmlns:sl="http://www.buergerkarte.at/namespaces/securitylayer/1.2#"><sl:KeyboxIdentifier>SecureSignatureKeypair</sl:KeyboxIdentifier><sl:DataObjectInfo Structure="enveloping"><sl:DataObject><sl:XMLContent>Ich bin ein einfacher Text.</sl:XMLContent></sl:DataObject><sl:TransformsInfo><sl:FinalDataMetaInfo><sl:MimeType>text/plain</sl:MimeType></sl:FinalDataMetaInfo></sl:TransformsInfo></sl:DataObjectInfo></sl:CreateXMLSignatureRequest>',
		'citizenQAALevel.name' => 'citizenQAALevel',
		'citizenQAALevel.uri' => 'http://www.stork.gov.eu/1.0/citizenQAALevel',
		'citizenQAALevel.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'citizenQAALevel.value' => NULL,
		'fiscalNumber.name' => 'fiscalNumber',
		'fiscalNumber.uri' => 'http://www.stork.gov.eu/1.0/fiscalNumber',
		'fiscalNumber.nameFormat' => 'urn:oasis:names:tc:SAML:2.0:attrname-format:uri',
		'fiscalNumber.value' => NULL,
  );
  
  public static $spcountries = array('LOCAL');

  public static $countries = array('LOCAL');
 
  public static function genAttrs($request) {
    $extensions = array();
    
    //extensions
    $extensions['stork:QualityAuthenticationAssuranceLevel'] = array_key_exists('qaaLevel', $request) ? $request['qaaLevel'] : 3;
    $extensions['stork:spCountry'] = $request['spcountry'];
    foreach(self::$confs as $key => $value) {
      $extensions[$key] = $value;
    }  

    //vidp
    $extensions['VIDP'] = array(
        'country' => $request['country'],
        'spid' => StorkConstants::SPID,
    );

   //requested attrubytes
   $attributes = array();
   foreach(self::$ids as $key) {
      $found = 0;
      if( $request[$key.'Type'] === 'true' ) {
        $found = 1;
        $attrStatus = 'true';
      } else if ( $request[$key.'Type'] === 'false'  ) {
        $found = 1;
        $attrStatus = 'false';
      }
      if ($found) {
        if (array_key_exists($key.'Value', $request)){
          $attrValue = $request[$key.'Value'];
        } else {
          $attrValue = self::$attrs[$key.'.value'];
        }
        $ra = new RequestedAttribute('stork', 'RequestedAttribute', self::$attrs[$key.'.name'], self::$attrs[$key.'.nameFormat'], $attrStatus, $attrValue);
        array_push($attributes, $ra); 
      }
   }

   if (!empty($attributes)) {
    $extensions['RequestedAttributes'] =  $attributes;
   }

   return $extensions;
  }
  
}
